https://pantsbuild.org/ logo
#general
Title
# general
b

bitter-ability-32190

03/22/2022, 8:06 PM
I have a eng who is having installation issues for a Python dep 🧵
Copy code
2022-03-22T12:54:13,150 ERROR: Could not find a version that satisfies the requirement audioread==2.1.8
2022-03-22T12:54:13,150 ERROR: No matching distribution found for audioread==2.1.8
1
From the log:
Copy code
2022-03-22T12:54:13,112 Collecting audioread==2.1.8
2022-03-22T12:54:13,113   Created temporary directory: /tmp/pip-unpack-15yktfpy
2022-03-22T12:54:13,113   Looking up "<https://files.pythonhosted.org/packages/2e/0b/940ea7861e0e9049f09dcfd72a90c9ae55f697c17c299a323f0148f913d2/audioread-2.1.8.tar.gz>" in the cache
2022-03-22T12:54:13,114   Current age based on date: 72997
2022-03-22T12:54:13,114   Ignoring unknown cache-control directive: immutable
2022-03-22T12:54:13,114   Freshness lifetime from max-age: 365000000
2022-03-22T12:54:13,114   The response is "fresh", returning cached response
2022-03-22T12:54:13,114   365000000 > 72997
2022-03-22T12:54:13,114   Using cached audioread-2.1.8.tar.gz (21 kB)
2022-03-22T12:54:13,118   Added audioread==2.1.8 from <https://files.pythonhosted.org/packages/2e/0b/940ea7861e0e9049f09dcfd72a90c9ae55f697c17c299a323f0148f913d2/audioread-2.1.8.tar.gz#sha256=073904fabc842881e07bd3e4a5776623535562f70b1655b635d22886168dd168> (from -r requirements.txt (line 60)) to build tracker '/tmp/pip-req-tracker-qq9hyzsw'
2022-03-22T12:54:13,119     Running setup.py (path:/tmp/pip-download-bewf3sch/audioread_1b162db4c1f24339bd713d93a674fa36/setup.py) egg_info for package audioread
2022-03-22T12:54:13,119     Created temporary directory: /tmp/pip-pip-egg-info-fqf6gz2p
2022-03-22T12:54:13,119     Running command python setup.py egg_info
2022-03-22T12:54:13,147     Traceback (most recent call last):
2022-03-22T12:54:13,147       File "<string>", line 1, in <module>
2022-03-22T12:54:13,147       File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/setuptools/__init__.py", line 18, in <module>
2022-03-22T12:54:13,147         from pex.third_party.setuptools.extern.six import PY3, string_types
2022-03-22T12:54:13,147     ModuleNotFoundError: No module named 'pex'
2022-03-22T12:54:13,150 WARNING: Discarding <https://files.pythonhosted.org/packages/2e/0b/940ea7861e0e9049f09dcfd72a90c9ae55f697c17c299a323f0148f913d2/audioread-2.1.8.tar.gz#sha256=073904fabc842881e07bd3e4a5776623535562f70b1655b635d22886168dd168> (from <https://pypi.org/simple/audioread/>). Command errored out with exit status 1: python setup.py egg_info Check the logs for full command output.
2022-03-22T12:54:13,150 ERROR: Could not find a version that satisfies the requirement audioread==2.1.8
2022-03-22T12:54:13,150 ERROR: No matching distribution found for audioread==2.1.8
2022-03-22T12:54:13,150 Exception information:
2022-03-22T12:54:13,150 Traceback (most recent call last):
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_vendor/resolvelib/resolvers.py", line 171, in _merge_into_criterion
2022-03-22T12:54:13,150     crit = self.state.criteria[name]
2022-03-22T12:54:13,150 KeyError: 'audioread'
2022-03-22T12:54:13,150
2022-03-22T12:54:13,150 During handling of the above exception, another exception occurred:
2022-03-22T12:54:13,150
2022-03-22T12:54:13,150 Traceback (most recent call last):
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_vendor/resolvelib/resolvers.py", line 318, in resolve
2022-03-22T12:54:13,150     name, crit = self._merge_into_criterion(r, parent=None)
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_vendor/resolvelib/resolvers.py", line 173, in _merge_into_criterion
2022-03-22T12:54:13,150     crit = Criterion.from_requirement(self._p, requirement, parent)
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_vendor/resolvelib/resolvers.py", line 83, in from_requirement
2022-03-22T12:54:13,150     raise RequirementsConflicted(criterion)
2022-03-22T12:54:13,150 pip._vendor.resolvelib.resolvers.RequirementsConflicted: Requirements conflict: SpecifierRequirement('audioread==2.1.8')
2022-03-22T12:54:13,150
2022-03-22T12:54:13,150 During handling of the above exception, another exception occurred:
2022-03-22T12:54:13,150
2022-03-22T12:54:13,150 Traceback (most recent call last):
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_internal/resolution/resolvelib/resolver.py", line 121, in resolve
2022-03-22T12:54:13,150     self._result = resolver.resolve(
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_vendor/resolvelib/resolvers.py", line 453, in resolve
2022-03-22T12:54:13,150     state = resolution.resolve(requirements, max_rounds=max_rounds)
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_vendor/resolvelib/resolvers.py", line 320, in resolve
2022-03-22T12:54:13,150     raise ResolutionImpossible(e.criterion.information)
2022-03-22T12:54:13,150 pip._vendor.resolvelib.resolvers.ResolutionImpossible: [RequirementInformation(requirement=SpecifierRequirement('audioread==2.1.8'), parent=None)]
2022-03-22T12:54:13,150
2022-03-22T12:54:13,150 The above exception was the direct cause of the following exception:
2022-03-22T12:54:13,150
2022-03-22T12:54:13,150 Traceback (most recent call last):
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_internal/cli/base_command.py", line 223, in _main
2022-03-22T12:54:13,150     status = self.run(options, args)
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_internal/cli/req_command.py", line 180, in wrapper
2022-03-22T12:54:13,150     return func(self, options, args)
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_internal/commands/download.py", line 130, in run
2022-03-22T12:54:13,150     requirement_set = resolver.resolve(
2022-03-22T12:54:13,150   File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/pip/_internal/resolution/resolvelib/resolver.py", line 127, in resolve
2022-03-22T12:54:13,150     six.raise_from(error, e)
2022-03-22T12:54:13,150   File "<string>", line 3, in raise_from
2022-03-22T12:54:13,150 pip._internal.exceptions.DistributionNotFound: No matching distribution found for audioread==2.1.8
2022-03-22T12:54:13,151 Removed audioread==2.1.8 from <https://files.pythonhosted.org/packages/2e/0b/940ea7861e0e9049f09dcfd72a90c9ae55f697c17c299a323f0148f913d2/audioread-2.1.8.tar.gz#sha256=073904fabc842881e07bd3e4a5776623535562f70b1655b635d22886168dd168> (from -r requirements.txt (line 60)) from build tracker '/tmp/pip-req-tracker-qq9hyzsw'
2022-03-22T12:54:13,152 Removed build tracker: '/tmp/pip-req-tracker-qq9hyzsw'
It kinda seems like the issue is we can't build a wheel for the library due to the following error?:
Copy code
2022-03-22T12:54:13,112 Collecting audioread==2.1.8
2022-03-22T12:54:13,113   Created temporary directory: /tmp/pip-unpack-15yktfpy
2022-03-22T12:54:13,113   Looking up "<https://files.pythonhosted.org/packages/2e/0b/940ea7861e0e9049f09dcfd72a90c9ae55f697c17c299a323f0148f913d2/audioread-2.1.8.tar.gz>" in the cache
2022-03-22T12:54:13,114   Current age based on date: 72997
2022-03-22T12:54:13,114   Ignoring unknown cache-control directive: immutable
2022-03-22T12:54:13,114   Freshness lifetime from max-age: 365000000
2022-03-22T12:54:13,114   The response is "fresh", returning cached response
2022-03-22T12:54:13,114   365000000 > 72997
2022-03-22T12:54:13,114   Using cached audioread-2.1.8.tar.gz (21 kB)
2022-03-22T12:54:13,118   Added audioread==2.1.8 from <https://files.pythonhosted.org/packages/2e/0b/940ea7861e0e9049f09dcfd72a90c9ae55f697c17c299a323f0148f913d2/audioread-2.1.8.tar.gz#sha256=073904fabc842881e07bd3e4a5776623535562f70b1655b635d22886168dd168> (from -r requirements.txt (line 60)) to build tracker '/tmp/pip-req-tracker-qq9hyzsw'
2022-03-22T12:54:13,119     Running setup.py (path:/tmp/pip-download-bewf3sch/audioread_1b162db4c1f24339bd713d93a674fa36/setup.py) egg_info for package audioread
2022-03-22T12:54:13,119     Created temporary directory: /tmp/pip-pip-egg-info-fqf6gz2p
2022-03-22T12:54:13,119     Running command python setup.py egg_info
2022-03-22T12:54:13,147     Traceback (most recent call last):
2022-03-22T12:54:13,147       File "<string>", line 1, in <module>
2022-03-22T12:54:13,147       File "/home/username/.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages/setuptools/__init__.py", line 18, in <module>
2022-03-22T12:54:13,147         from pex.third_party.setuptools.extern.six import PY3, string_types
2022-03-22T12:54:13,147     ModuleNotFoundError: No module named 'pex'
s

strong-toothbrush-37759

03/22/2022, 8:09 PM
We had issues like this one the last couple of days with some data-science libraries in our CI. It seems to me like this might be due to network related issues. Does this issue persist with new tries?
b

bitter-ability-32190

03/22/2022, 8:10 PM
It does
s

strong-toothbrush-37759

03/22/2022, 8:10 PM
Oh wait, it says
pex
is not installed 🤔
w

witty-crayon-22786

03/22/2022, 8:36 PM
@bitter-ability-32190: i think that this might be https://github.com/pantsbuild/pex/issues/1386 …?
is this a macOS machine (or did they otherwise change symlinks to python installs?)
b

bitter-ability-32190

03/22/2022, 8:38 PM
Ubuntu 20
I doubt they changed any symlinks. Whats the easiest way to detect?
w

witty-crayon-22786

03/22/2022, 8:42 PM
@bitter-ability-32190: to unblock them, could you have them stash the PEX root? i.e., move
~/.cache/pants/named_caches/pex_root
somewhere else?
👀 1
the way to detect is to look for a mismatch between the Python that is failing to find something, and the site-packages directory of the virtualenv the error is occurring in (
.cache/pants/named_caches/pex_root/venvs/s/ec58be6e/venv/lib/python3.8/site-packages
in one case here). the idea being that the venv has been created for a different python than it is being used with (?)
so, if 3.7 or 3.9 was being used with a 3.8 venv
b

bitter-ability-32190

03/22/2022, 9:21 PM
I'll tell them to wipe cache and try again. Will report back tomorrow with outcome
Wiping the cache doesn't fix the issue
w

witty-crayon-22786

03/22/2022, 10:45 PM
hm, sorry… false alarm on https://github.com/pantsbuild/pex/issues/1386 then most likely. which version of Pants is this? the next step is most likely to use https://www.pantsbuild.org/v2.10/docs/troubleshooting#debug-tip-inspect-the-sandbox-with---no-process-cleanup to get access to the created sandbox, and then begin making modifications to the support scripts to get more nearby details.
i.e., assuming it fails with
__run.sh
in the sandbox, inspect which virtualenv is being used, and then inspect the contents of the virtualenv to see why
pex
might not be located.
or, if you jump straight to looking at the venv from the error message, trying to determine whether the
site-packages
in that venv actually do contain
pex
b

bitter-ability-32190

03/22/2022, 11:31 PM
Hmm good suggestions
w

witty-crayon-22786

03/22/2022, 11:47 PM
very sorry for the trouble. definitely interested in tracking these down… the pex mutable (“named”) cache is a deal with the devil to reduce the overhead of tracking many thousands of loose files.
😈 1
b

bitter-ability-32190

03/23/2022, 7:07 PM
or, if you jump straight to looking at the venv from the error message, trying to determine whether the
site-packages
in that venv actually do contain
pex
Yeah the venv contains
__pex_patched_pip__.py
but not
pex
itself
w

witty-crayon-22786

03/23/2022, 7:09 PM
so you repro the issue with
__run.sh
…? can start adding debug output from there.
b

bitter-ability-32190

03/23/2022, 7:09 PM
Yup!
Not sure where to start debugging though
w

witty-crayon-22786

03/23/2022, 7:15 PM
the scripts inside the sandbox should be causing a venv to be created (or, if it already exists, to be reused) and then activated
…from a PEX located within the sandbox
so, one thing to maybe check is whether the PEX in the sandbox is itself valid: if it is valid, then the “venv creation or reuse” step is probably to blame
if it is not valid, then would need to back up a step to see where the invalid/partial PEX came from.
zipapp PEXes are just zip files (which in this case should contain
pex
itself: a PEX of
pex
), but they also contain a PEX-INFO file with more info.
b

bitter-ability-32190

03/23/2022, 7:19 PM
How would I check validity?
w

witty-crayon-22786

03/23/2022, 7:19 PM
see whether the PEX contains
pex
and perhaps also just checking whether you can run it.
b

bitter-ability-32190

03/23/2022, 7:20 PM
<path>python3.8 ./pex --help
works
w

witty-crayon-22786

03/23/2022, 7:21 PM
ok. so that would point to the creation of the
venv
from the PEX maybe being the issue.
b

bitter-ability-32190

03/23/2022, 7:24 PM
./<path>/python3.8 ./pex audioread==2.1.8 --output-file foo
works as well
w

witty-crayon-22786

03/23/2022, 7:25 PM
take a look inside the
__run.sh
script to get a better idea of what this process is actually doing
b

bitter-ability-32190

03/23/2022, 7:25 PM
Yeah, I'm gonna keep tacking on args until it fails
(sorry we get to play telephone 🙈 )
w

witty-crayon-22786

03/23/2022, 7:25 PM
yea… unfortunately because this is probably Python-install specific, it’s probably not terribly portable.
b

bitter-ability-32190

03/23/2022, 7:31 PM
As soon as I tack on
--requirement requirements.txt
is when the 💥 happens
OK so small update, using the similar ish command as
__runs.sh
to install just
pycairo
has an error (that isn't the
pex
one) where
setup.py
runs
pkg-config --print-errors --exists cairo>=1.15.10
and errors if there's output. This command has no output on my machine but does have output on the afflicted machine. So it might be an issue with the machine's setup as opposed to Pants. Both of our system have the same version of
libcairo2-dev
installed though. So a possible lead, or a possible red-herring
h

happy-kitchen-89482

03/24/2022, 5:17 PM
Any updates on this?
b

bitter-ability-32190

03/24/2022, 5:18 PM
pycairo
is installable outside of the sandbox. Thats about the only update 😞
Annnd now it isn't installable. 🎉 Pants is 100% a red herring
h

happy-kitchen-89482

03/29/2022, 1:16 AM
That sounds, ahem, fishy...
👀 1
b

bitter-ability-32190

03/29/2022, 1:20 AM
I think something changed on the system that makes the library unbuildable from source. The prior litmus installation test was likely using a cached package
h

happy-kitchen-89482

03/29/2022, 3:11 AM
I was just making a "red herring" joke 😉
🐟 2
Since @fast-nail-55400 wasn't stepping up
l

little-pilot-11155

01/26/2024, 5:06 PM
I apologise for resurrecting an old thread but observing the same error across multiple VMs. More details below. Unfortunately, I don't know how to reproduce the issue 😕 The error shown originally is this one:
Copy code
pid 53511 -> /home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/bin/python -sE //home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/pex --disable-pip-version-check --no-python-version-warning --exists-action a --no-input --isolated -q --cache-dir /home/user/.cache/pants/named_caches/pex_root/pip_cache --log /tmp/pants-sandbox-BJYm0N/.tmp/pex-pip-log.5w2d2bex/pip.log download --dest /home/user/.cache/pants/named_caches/pex_root/downloads/resolver_download.6uns87z7/opt.pyenv.versions.3.9.18.bin.python3.9 --no-deps --requirement requirements.txt --index-url <https://pypi.org/simple/> --extra-index-url <https://download.pytorch.org/whl/cpu> --retries 5 --timeout 15 exited with -9 and STDERR:
None
After digging into the sandbox, I found the stack trace:
Copy code
Given no hashes to check 1 links for project 'starkbank-ecdsa': discarding no candidates
Collecting starkbank-ecdsa==2.2.0
  Created temporary directory: /tmp/pip-unpack-l24vh39m
  Looking up "<https://files.pythonhosted.org/packages/a3/f8/a6091be6a60ed4df9ac806c89fbc5fe1a3416d0284f3ba70aa09a3419428/starkbank-ecdsa-2.2.0.tar.gz>" in the cache
  Current age based on date: 6425
  Ignoring unknown cache-control directive: immutable
  Freshness lifetime from max-age: 365000000
  The response is "fresh", returning cached response
  365000000 > 6425
  Using cached starkbank-ecdsa-2.2.0.tar.gz (14 kB)
  Added starkbank-ecdsa==2.2.0 from <https://files.pythonhosted.org/packages/a3/f8/a6091be6a60ed4df9ac806c89fbc5fe1a3416d0284f3ba70aa09a3419428/starkbank-ecdsa-2.2.0.tar.gz#sha256=9399c3371b899d4a235b68a1ed7919d202fbf024bd2c863ae8ebdad343c2a63a> to
 build tracker '/tmp/pip-req-tracker-dba762du'
    Running setup.py (path:/tmp/pip-download-6ajlzrfk/starkbank-ecdsa_3421027f5c9848669117a811c6626dee/setup.py) egg_info for package starkbank-ecdsa
    Created temporary directory: /tmp/pip-pip-egg-info-nmavdv7n
    Running command python setup.py egg_info
    Traceback (most recent call last):
      File "<string>", line 1, in <module>
      File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/setuptools/__init__.py", line 18, in <module>
        from pex.third_party.setuptools.extern.six import PY3, string_types
    ModuleNotFoundError: No module named 'pex'
WARNING: Discarding <https://files.pythonhosted.org/packages/a3/f8/a6091be6a60ed4df9ac806c89fbc5fe1a3416d0284f3ba70aa09a3419428/starkbank-ecdsa-2.2.0.tar.gz#sha256=9399c3371b899d4a235b68a1ed7919d202fbf024bd2c863ae8ebdad343c2a63a> (from <https://pypi>
.org/simple/starkbank-ecdsa/). Command errored out with exit status 1: python setup.py egg_info Check the logs for full command output.
ERROR: Could not find a version that satisfies the requirement starkbank-ecdsa==2.2.0
ERROR: No matching distribution found for starkbank-ecdsa==2.2.0
Exception information:
Traceback (most recent call last):
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_vendor/resolvelib/resolvers.py", line 171, in _merge
_into_criterion
    crit = self.state.criteria[name]
KeyError: 'starkbank-ecdsa'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_vendor/resolvelib/resolvers.py", line 318, in resolv
e
    name, crit = self._merge_into_criterion(r, parent=None)
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_vendor/resolvelib/resolvers.py", line 173, in _merge
_into_criterion
    crit = Criterion.from_requirement(self._p, requirement, parent)
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_vendor/resolvelib/resolvers.py", line 83, in from_re
quirement
    raise RequirementsConflicted(criterion)
pip._vendor.resolvelib.resolvers.RequirementsConflicted: Requirements conflict: SpecifierRequirement('starkbank-ecdsa==2.2.0')

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_internal/resolution/resolvelib/resolver.py", line 12
1, in resolve
    self._result = resolver.resolve(
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_vendor/resolvelib/resolvers.py", line 453, in resolv
e
    state = resolution.resolve(requirements, max_rounds=max_rounds)
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_vendor/resolvelib/resolvers.py", line 320, in resolv
e
    raise ResolutionImpossible(e.criterion.information)
pip._vendor.resolvelib.resolvers.ResolutionImpossible: [RequirementInformation(requirement=SpecifierRequirement('starkbank-ecdsa==2.2.0'), parent=None)]

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_internal/cli/base_command.py", line 223, in _main
    status = self.run(options, args)
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_internal/cli/req_command.py", line 180, in wrapper
    return func(self, options, args)
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_internal/commands/download.py", line 130, in run
    requirement_set = resolver.resolve(
  File "/home/user/.cache/pants/named_caches/pex_root/venvs/4c8c3db86a2241e1ebbf9fb431070a582d5b7160/6dbeff08cbe318121daf6feadb1cdfb4c3676a18/lib/python3.9/site-packages/pip/_internal/resolution/resolvelib/resolver.py", line 12
7, in resolve
    six.raise_from(error, e)
  File "<string>", line 3, in raise_from
pip._internal.exceptions.DistributionNotFound: No matching distribution found for starkbank-ecdsa==2.2.0
Removed starkbank-ecdsa==2.2.0 from <https://files.pythonhosted.org/packages/a3/f8/a6091be6a60ed4df9ac806c89fbc5fe1a3416d0284f3ba70aa09a3419428/starkbank-ecdsa-2.2.0.tar.gz#sha256=9399c3371b899d4a235b68a1ed7919d202fbf024bd2c863ae8ebdad343c2a63a> fr
om build tracker '/tmp/pip-req-tracker-dba762du'
Removed build tracker: '/tmp/pip-req-tracker-dba762du'
That wasn't the only lib that was failing. After commenting out broken deps, this is the list that I came up with: •
fire==0.5.0 ; python_version >= "3.9" and python_version < "4.0"
flask-testing==0.8.1 ; python_version >= "3.9" and python_version < "4.0"
memory-profiler==0.58.0 ; python_version >= "3.9" and python_version < "4.0"
mypy-extensions==0.4.4 ; python_version >= "3.9" and python_version < "4.0"
pyrepl==0.9.0 ; python_version >= "3.9" and python_version < "4.0"
python-constraint==1.4.0 ; python_version >= "3.9" and python_version < "4.0"
starkbank-ecdsa==2.2.0 ; python_version >= "3.9" and python_version < "4.0"
Some additional information: • Pants version:
2.15.2
• Pex version:
2.1.111
• OS:
Ubuntu 22.04.3 LTS
• Virtualisation:
Docker container on GKE
• Remote Cache/Exec with Buildbarn •
interpreter_constraints = ["==3.9.*"]
• Code base consists both Python and Golang so sometimes Pants execution gets killed by OOM Sometimes, I managed to fix it with:
Copy code
rm -rf ~/.cache/{nce,pants} && rm -rf .pants.d && rm -rf ~/.pex && pkill pantsd
but not always. Then I try clearing pip cache and finally, reinstall my virtual env. Any tips on how I can progress with finding the root cause?
5 Views